﻿#pragma once
/*
  ==============================================================================

   This file is part of the Shooting3
   Copyright 2005-11 by Satoshi Fujiwara.

   async can be redistributed and/or modified under the terms of the
   GNU General Public License, as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.

   async is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with async; if not, visit www.gnu.org/licenses or write to the
   Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
   Boston, MA 02111-1307 USA

  ==============================================================================
*/
/** @file
 *  @brief util
 *  @author S.F. (Satoshi Fujiwara)
 */
#include "objbase.h"



namespace sf 
{
    enum com_init 
    {
        multi_threaded  = 0x0,
        apartment_threaded = 0x2,
        disable_ole1dde   = 0x4,
        speed_over_memory = 0x8
    };

    struct com_initialize
    {
        struct impl;
        com_initialize(void * reserved ,unsigned int init);
        com_initialize(){com_initialize(0,multi_threaded);};
        ~com_initialize() {};
    private:
        std::shared_ptr<impl> m_impl;
    };


}